# -*- coding: utf-8 -*-

"""
accountandtransactionapispecification

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from accountandtransactionapispecification.api_helper import APIHelper
from accountandtransactionapispecification.configuration import Server
from accountandtransactionapispecification.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from accountandtransactionapispecification.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from accountandtransactionapispecification.models.get_account_statement_response import GetAccountStatementResponse
from accountandtransactionapispecification.models.get_account_statement_transactions_response import GetAccountStatementTransactionsResponse
from accountandtransactionapispecification.models.get_account_statements_response import GetAccountStatementsResponse
from accountandtransactionapispecification.models.get_statements_response import GetStatementsResponse
from accountandtransactionapispecification.exceptions.accounts_statements_400_error_exception import AccountsStatements400ErrorException
from accountandtransactionapispecification.exceptions.api_exception import APIException
from accountandtransactionapispecification.exceptions.accounts_statements_403_error_exception import AccountsStatements403ErrorException
from accountandtransactionapispecification.exceptions.accounts_statements_500_error_exception import AccountsStatements500ErrorException
from accountandtransactionapispecification.exceptions.accounts_statements_503_error_exception import AccountsStatements503ErrorException
from accountandtransactionapispecification.exceptions.accounts_statements_transactions_400_error_exception import AccountsStatementsTransactions400ErrorException
from accountandtransactionapispecification.exceptions.accounts_statements_transactions_403_error_exception import AccountsStatementsTransactions403ErrorException
from accountandtransactionapispecification.exceptions.accounts_statements_transactions_500_error_exception import AccountsStatementsTransactions500ErrorException
from accountandtransactionapispecification.exceptions.accounts_statements_transactions_503_error_exception import AccountsStatementsTransactions503ErrorException
from accountandtransactionapispecification.exceptions.statements_400_error_exception import Statements400ErrorException
from accountandtransactionapispecification.exceptions.statements_403_error_exception import Statements403ErrorException
from accountandtransactionapispecification.exceptions.statements_500_error_exception import Statements500ErrorException
from accountandtransactionapispecification.exceptions.statements_503_error_exception import Statements503ErrorException


class StatementsController(BaseController):

    """A Controller to access Endpoints in the accountandtransactionapispecification API."""
    def __init__(self, config):
        super(StatementsController, self).__init__(config)

    def get_account_statement(self,
                              account_id,
                              statement_id,
                              from_statement_date_time=None,
                              to_statement_date_time=None,
                              x_fapi_auth_date=None,
                              x_fapi_customer_ip_address=None,
                              x_fapi_interaction_id=None,
                              x_merchant_ip_address=None,
                              x_customer_user_agent=None):
        """Does a GET request to /accounts/{AccountId}/statements/{StatementId}.

        Get Statement related to an account

        Args:
            account_id (str): A unique identifier used to identify the account
                resource.
            statement_id (str): A unique identifier used to identify the
                statement resource.
            from_statement_date_time (datetime, optional): The UTC ISO 8601
                Date Time to filter statements FROM NB Time component is
                optional - set to 00:00:00 for just Date. If the Date Time
                contains a timezone, the API Provider must ignore the timezone
                component.
            to_statement_date_time (datetime, optional): The UTC ISO 8601 Date
                Time to filter statements TO NB Time component is optional -
                set to 00:00:00 for just Date. If the Date Time contains a
                timezone, the API Provider must ignore the timezone component.
            x_fapi_auth_date (str, optional): The time when the Customer last
                logged in with the Third Party. All dates in the HTTP headers
                are represented as RFC 7231 Full Dates. An example is below:
                Sun, 10 Sep 2017 19:43:31 UTC
            x_fapi_customer_ip_address (str, optional): The Customer's IP
                address if the Customer is currently logged in with the Third
                Party.
            x_fapi_interaction_id (str, optional): An RFC4122 UID used as a
                correlation id.
            x_merchant_ip_address (str, optional): The IP address of the
                merchant when making account information requests through a
                Third Party.
            x_customer_user_agent (str, optional): The User-Agent of the
                application on the customer device that is used to make the
                account information request

        Returns:
            GetAccountStatementResponse: Response from the API. Account
                Statement successfully retrieved

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/accounts/{AccountId}/statements/{StatementId}')
            .http_method(HttpMethodEnum.GET)
            .template_param(Parameter()
                            .key('AccountId')
                            .value(account_id)
                            .should_encode(True))
            .template_param(Parameter()
                            .key('StatementId')
                            .value(statement_id)
                            .should_encode(True))
            .query_param(Parameter()
                         .key('fromStatementDateTime')
                         .value(APIHelper.when_defined(APIHelper.RFC3339DateTime, from_statement_date_time)))
            .query_param(Parameter()
                         .key('toStatementDateTime')
                         .value(APIHelper.when_defined(APIHelper.RFC3339DateTime, to_statement_date_time)))
            .header_param(Parameter()
                          .key('x-fapi-auth-date')
                          .value(x_fapi_auth_date))
            .header_param(Parameter()
                          .key('x-fapi-customer-ip-address')
                          .value(x_fapi_customer_ip_address))
            .header_param(Parameter()
                          .key('x-fapi-interaction-id')
                          .value(x_fapi_interaction_id))
            .header_param(Parameter()
                          .key('x-merchant-ip-address')
                          .value(x_merchant_ip_address))
            .header_param(Parameter()
                          .key('x-customer-user-agent')
                          .value(x_customer_user_agent))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('HTTPBearerAuthentication'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(GetAccountStatementResponse.from_dictionary)
            .local_error('400', 'Bad Request', AccountsStatements400ErrorException)
            .local_error('401', 'Unauthorized', APIException)
            .local_error('403', 'Forbidden', AccountsStatements403ErrorException)
            .local_error('405', 'Method Not Allowed', APIException)
            .local_error('406', 'Not Acceptable', APIException)
            .local_error('429', 'Too Many Requests', APIException)
            .local_error('500', 'Internal Server Error', AccountsStatements500ErrorException)
            .local_error('501', 'Not Implemented', APIException)
            .local_error('503', 'Service Unavailable', AccountsStatements503ErrorException)
        ).execute()

    def get_account_statement_file(self,
                                   account_id,
                                   statement_id,
                                   x_fapi_auth_date=None,
                                   x_fapi_customer_ip_address=None,
                                   x_fapi_interaction_id=None,
                                   x_merchant_ip_address=None,
                                   x_customer_user_agent=None):
        """Does a GET request to /accounts/{AccountId}/statements/{StatementId}/file.

        Get Statement related to an account

        Args:
            account_id (str): A unique identifier used to identify the account
                resource.
            statement_id (str): A unique identifier used to identify the
                statement resource.
            x_fapi_auth_date (str, optional): The time when the Customer last
                logged in with the Third Party. All dates in the HTTP headers
                are represented as RFC 7231 Full Dates. An example is below:
                Sun, 10 Sep 2017 19:43:31 UTC
            x_fapi_customer_ip_address (str, optional): The Customer's IP
                address if the Customer is currently logged in with the Third
                Party.
            x_fapi_interaction_id (str, optional): An RFC4122 UID used as a
                correlation id.
            x_merchant_ip_address (str, optional): The IP address of the
                merchant when making account information requests through a
                Third Party.
            x_customer_user_agent (str, optional): The User-Agent of the
                application on the customer device that is used to make the
                account information request

        Returns:
            object: Response from the API. Account Statement File successfully
                retrieved

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/accounts/{AccountId}/statements/{StatementId}/file')
            .http_method(HttpMethodEnum.GET)
            .template_param(Parameter()
                            .key('AccountId')
                            .value(account_id)
                            .should_encode(True))
            .template_param(Parameter()
                            .key('StatementId')
                            .value(statement_id)
                            .should_encode(True))
            .header_param(Parameter()
                          .key('x-fapi-auth-date')
                          .value(x_fapi_auth_date))
            .header_param(Parameter()
                          .key('x-fapi-customer-ip-address')
                          .value(x_fapi_customer_ip_address))
            .header_param(Parameter()
                          .key('x-fapi-interaction-id')
                          .value(x_fapi_interaction_id))
            .header_param(Parameter()
                          .key('x-merchant-ip-address')
                          .value(x_merchant_ip_address))
            .header_param(Parameter()
                          .key('x-customer-user-agent')
                          .value(x_customer_user_agent))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('HTTPBearerAuthentication'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .local_error('400', 'Bad Request', APIException)
            .local_error('401', 'Unauthorized', APIException)
            .local_error('403', 'Forbidden', APIException)
            .local_error('405', 'Method Not Allowed', APIException)
            .local_error('406', 'Not Acceptable', APIException)
            .local_error('429', 'Too Many Requests', APIException)
            .local_error('500', 'Internal Server Error', APIException)
            .local_error('501', 'Not Implemented', APIException)
            .local_error('503', 'Service Unavailable', APIException)
        ).execute()

    def get_account_statement_transactions(self,
                                           account_id,
                                           statement_id,
                                           from_booking_date_time=None,
                                           to_booking_date_time=None,
                                           x_fapi_auth_date=None,
                                           x_fapi_customer_ip_address=None,
                                           x_fapi_interaction_id=None,
                                           x_merchant_ip_address=None,
                                           x_customer_user_agent=None):
        """Does a GET request to /accounts/{AccountId}/statements/{StatementId}/transactions.

        Get Statement Transactions related to an account

        Args:
            account_id (str): A unique identifier used to identify the account
                resource.
            statement_id (str): A unique identifier used to identify the
                statement resource.
            from_booking_date_time (datetime, optional): The UTC ISO 8601 Date
                Time to filter transactions FROM NB Time component is optional
                - set to 00:00:00 for just Date. If the Date Time contains a
                timezone, the API Provider must ignore the timezone component.
            to_booking_date_time (datetime, optional): The UTC ISO 8601 Date
                Time to filter transactions TO NB Time component is optional -
                set to 00:00:00 for just Date. If the Date Time contains a
                timezone, the API Provider must ignore the timezone component.
            x_fapi_auth_date (str, optional): The time when the Customer last
                logged in with the Third Party. All dates in the HTTP headers
                are represented as RFC 7231 Full Dates. An example is below:
                Sun, 10 Sep 2017 19:43:31 UTC
            x_fapi_customer_ip_address (str, optional): The Customer's IP
                address if the Customer is currently logged in with the Third
                Party.
            x_fapi_interaction_id (str, optional): An RFC4122 UID used as a
                correlation id.
            x_merchant_ip_address (str, optional): The IP address of the
                merchant when making account information requests through a
                Third Party.
            x_customer_user_agent (str, optional): The User-Agent of the
                application on the customer device that is used to make the
                account information request

        Returns:
            GetAccountStatementTransactionsResponse: Response from the API.
                Account Transactions successfully retrieved

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/accounts/{AccountId}/statements/{StatementId}/transactions')
            .http_method(HttpMethodEnum.GET)
            .template_param(Parameter()
                            .key('AccountId')
                            .value(account_id)
                            .should_encode(True))
            .template_param(Parameter()
                            .key('StatementId')
                            .value(statement_id)
                            .should_encode(True))
            .query_param(Parameter()
                         .key('fromBookingDateTime')
                         .value(APIHelper.when_defined(APIHelper.RFC3339DateTime, from_booking_date_time)))
            .query_param(Parameter()
                         .key('toBookingDateTime')
                         .value(APIHelper.when_defined(APIHelper.RFC3339DateTime, to_booking_date_time)))
            .header_param(Parameter()
                          .key('x-fapi-auth-date')
                          .value(x_fapi_auth_date))
            .header_param(Parameter()
                          .key('x-fapi-customer-ip-address')
                          .value(x_fapi_customer_ip_address))
            .header_param(Parameter()
                          .key('x-fapi-interaction-id')
                          .value(x_fapi_interaction_id))
            .header_param(Parameter()
                          .key('x-merchant-ip-address')
                          .value(x_merchant_ip_address))
            .header_param(Parameter()
                          .key('x-customer-user-agent')
                          .value(x_customer_user_agent))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('HTTPBearerAuthentication'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(GetAccountStatementTransactionsResponse.from_dictionary)
            .local_error('400', 'Bad Request', AccountsStatementsTransactions400ErrorException)
            .local_error('401', 'Unauthorized', APIException)
            .local_error('403', 'Forbidden', AccountsStatementsTransactions403ErrorException)
            .local_error('405', 'Method Not Allowed', APIException)
            .local_error('406', 'Not Acceptable', APIException)
            .local_error('429', 'Too Many Requests', APIException)
            .local_error('500', 'Internal Server Error', AccountsStatementsTransactions500ErrorException)
            .local_error('501', 'Not Implemented', APIException)
            .local_error('503', 'Service Unavailable', AccountsStatementsTransactions503ErrorException)
        ).execute()

    def get_account_statements(self,
                               account_id,
                               from_statement_date_time=None,
                               to_statement_date_time=None,
                               x_fapi_auth_date=None,
                               x_fapi_customer_ip_address=None,
                               x_fapi_interaction_id=None,
                               x_merchant_ip_address=None,
                               x_customer_user_agent=None):
        """Does a GET request to /accounts/{AccountId}/statements.

        Get Statements related to an account

        Args:
            account_id (str): A unique identifier used to identify the account
                resource.
            from_statement_date_time (datetime, optional): The UTC ISO 8601
                Date Time to filter statements FROM NB Time component is
                optional - set to 00:00:00 for just Date. If the Date Time
                contains a timezone, the API Provider must ignore the timezone
                component.
            to_statement_date_time (datetime, optional): The UTC ISO 8601 Date
                Time to filter statements TO NB Time component is optional -
                set to 00:00:00 for just Date. If the Date Time contains a
                timezone, the API Provider must ignore the timezone component.
            x_fapi_auth_date (str, optional): The time when the Customer last
                logged in with the Third Party. All dates in the HTTP headers
                are represented as RFC 7231 Full Dates. An example is below:
                Sun, 10 Sep 2017 19:43:31 UTC
            x_fapi_customer_ip_address (str, optional): The Customer's IP
                address if the Customer is currently logged in with the Third
                Party.
            x_fapi_interaction_id (str, optional): An RFC4122 UID used as a
                correlation id.
            x_merchant_ip_address (str, optional): The IP address of the
                merchant when making account information requests through a
                Third Party.
            x_customer_user_agent (str, optional): The User-Agent of the
                application on the customer device that is used to make the
                account information request

        Returns:
            GetAccountStatementsResponse: Response from the API. Account
                Statement successfully retrieved

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/accounts/{AccountId}/statements')
            .http_method(HttpMethodEnum.GET)
            .template_param(Parameter()
                            .key('AccountId')
                            .value(account_id)
                            .should_encode(True))
            .query_param(Parameter()
                         .key('fromStatementDateTime')
                         .value(APIHelper.when_defined(APIHelper.RFC3339DateTime, from_statement_date_time)))
            .query_param(Parameter()
                         .key('toStatementDateTime')
                         .value(APIHelper.when_defined(APIHelper.RFC3339DateTime, to_statement_date_time)))
            .header_param(Parameter()
                          .key('x-fapi-auth-date')
                          .value(x_fapi_auth_date))
            .header_param(Parameter()
                          .key('x-fapi-customer-ip-address')
                          .value(x_fapi_customer_ip_address))
            .header_param(Parameter()
                          .key('x-fapi-interaction-id')
                          .value(x_fapi_interaction_id))
            .header_param(Parameter()
                          .key('x-merchant-ip-address')
                          .value(x_merchant_ip_address))
            .header_param(Parameter()
                          .key('x-customer-user-agent')
                          .value(x_customer_user_agent))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('HTTPBearerAuthentication'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(GetAccountStatementsResponse.from_dictionary)
            .local_error('400', 'Bad Request', AccountsStatements400ErrorException)
            .local_error('401', 'Unauthorized', APIException)
            .local_error('403', 'Forbidden', AccountsStatements403ErrorException)
            .local_error('405', 'Method Not Allowed', APIException)
            .local_error('406', 'Not Acceptable', APIException)
            .local_error('429', 'Too Many Requests', APIException)
            .local_error('500', 'Internal Server Error', AccountsStatements500ErrorException)
            .local_error('501', 'Not Implemented', APIException)
            .local_error('503', 'Service Unavailable', AccountsStatements503ErrorException)
        ).execute()

    def get_statements(self,
                       from_statement_date_time=None,
                       to_statement_date_time=None,
                       x_fapi_auth_date=None,
                       x_fapi_customer_ip_address=None,
                       x_fapi_interaction_id=None,
                       x_merchant_ip_address=None,
                       x_customer_user_agent=None):
        """Does a GET request to /statements.

        Get Statements

        Args:
            from_statement_date_time (datetime, optional): The UTC ISO 8601
                Date Time to filter statements FROM NB Time component is
                optional - set to 00:00:00 for just Date. If the Date Time
                contains a timezone, the API Provider must ignore the timezone
                component.
            to_statement_date_time (datetime, optional): The UTC ISO 8601 Date
                Time to filter statements TO NB Time component is optional -
                set to 00:00:00 for just Date. If the Date Time contains a
                timezone, the API Provider must ignore the timezone component.
            x_fapi_auth_date (str, optional): The time when the Customer last
                logged in with the Third Party. All dates in the HTTP headers
                are represented as RFC 7231 Full Dates. An example is below:
                Sun, 10 Sep 2017 19:43:31 UTC
            x_fapi_customer_ip_address (str, optional): The Customer's IP
                address if the Customer is currently logged in with the Third
                Party.
            x_fapi_interaction_id (str, optional): An RFC4122 UID used as a
                correlation id.
            x_merchant_ip_address (str, optional): The IP address of the
                merchant when making account information requests through a
                Third Party.
            x_customer_user_agent (str, optional): The User-Agent of the
                application on the customer device that is used to make the
                account information request

        Returns:
            GetStatementsResponse: Response from the API. Account Statement
                successfully retrieved

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/statements')
            .http_method(HttpMethodEnum.GET)
            .query_param(Parameter()
                         .key('fromStatementDateTime')
                         .value(APIHelper.when_defined(APIHelper.RFC3339DateTime, from_statement_date_time)))
            .query_param(Parameter()
                         .key('toStatementDateTime')
                         .value(APIHelper.when_defined(APIHelper.RFC3339DateTime, to_statement_date_time)))
            .header_param(Parameter()
                          .key('x-fapi-auth-date')
                          .value(x_fapi_auth_date))
            .header_param(Parameter()
                          .key('x-fapi-customer-ip-address')
                          .value(x_fapi_customer_ip_address))
            .header_param(Parameter()
                          .key('x-fapi-interaction-id')
                          .value(x_fapi_interaction_id))
            .header_param(Parameter()
                          .key('x-merchant-ip-address')
                          .value(x_merchant_ip_address))
            .header_param(Parameter()
                          .key('x-customer-user-agent')
                          .value(x_customer_user_agent))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('HTTPBearerAuthentication'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(GetStatementsResponse.from_dictionary)
            .local_error('400', 'Bad Request', Statements400ErrorException)
            .local_error('401', 'Unauthorized', APIException)
            .local_error('403', 'Forbidden', Statements403ErrorException)
            .local_error('405', 'Method Not Allowed', APIException)
            .local_error('406', 'Not Acceptable', APIException)
            .local_error('429', 'Too Many Requests', APIException)
            .local_error('500', 'Internal Server Error', Statements500ErrorException)
            .local_error('501', 'Not Implemented', APIException)
            .local_error('503', 'Service Unavailable', Statements503ErrorException)
        ).execute()
