# -*- coding: utf-8 -*-

"""
accountandtransactionapispecification

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from accountandtransactionapispecification.api_helper import APIHelper


class GeoLocation(object):

    """Implementation of the 'GeoLocation' model.

    Location of the end-user on the earth specified by two numbers
    representing vertical and horizontal position

    Attributes:
        latitude (str): Latitude measured in decimal degress
        longitude (str): Longitude measured in decimal degress

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "latitude": 'Latitude',
        "longitude": 'Longitude'
    }

    _optionals = [
        'latitude',
        'longitude',
    ]

    def __init__(self,
                 latitude=APIHelper.SKIP,
                 longitude=APIHelper.SKIP):
        """Constructor for the GeoLocation class"""

        # Initialize members of the class
        if latitude is not APIHelper.SKIP:
            self.latitude = latitude 
        if longitude is not APIHelper.SKIP:
            self.longitude = longitude 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        latitude = dictionary.get("Latitude") if dictionary.get("Latitude") else APIHelper.SKIP
        longitude = dictionary.get("Longitude") if dictionary.get("Longitude") else APIHelper.SKIP
        # Return an object of this model
        return cls(latitude,
                   longitude)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'latitude={(self.latitude if hasattr(self, "latitude") else None)!r}, '
                f'longitude={(self.longitude if hasattr(self, "longitude") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'latitude={(self.latitude if hasattr(self, "latitude") else None)!s}, '
                f'longitude={(self.longitude if hasattr(self, "longitude") else None)!s})')
